#include "ind_strategy.h" 

void IndiStrategy::reward(int _reward) {

  record *= 4; // shift
  record %= 64; // forget the 4-th record
  
  switch (_reward) {
  case CC :  // (CC) both cooperated
    record |=  Me_C; 
    record |=  Oponent_C; 
    break;  
  case CD :  // (CD) I cooperated, oponent decieved 
    record |=  Me_C; 
    record |=  Oponent_D; 
    break; 
  case DC :  // (DC) I decieved, oponent cooperated 
    record |=  Me_D; 
    record |=  Oponent_C; 
    break;  
  case DD :  // (DD) both decieved 
    record |=  Me_D; 
    record |=  Oponent_D; 
    break; 
  default:
    throw std::runtime_error("Unknown reward.");
  } 

} 

int IndiStrategy::operator()() {
  
  if (first) { // first turn 
    // use last 6 bits
    for (int i=64; i<70; i++) {
      record *= 2; 
      record += bitmap[i]; 
    } 
    first = false; 
  }
  return bitmap[record];   
} 

void IndiStrategy::print() {

  vector<string> labels;
  labels.resize(8); 


  labels[0] = "CCC"; labels[1] = "CCD"; labels[2] = "CDC";   labels[3] = "CDD"; 
  labels[4] = "DCC"; labels[5] = "DCD"; labels[6] = "DDC";   labels[7] = "DDD"; 

  int convert_me[8] = { 0, 2, 8, 10, 32, 34, 40, 42 };
  int convert_op[8] = { 0, 1, 4, 5, 16, 17, 20, 21 }; 

  cout << "     "; 
  for (int i=0; i<8; i++) 
    cout << labels[i] <<  "  ";
  cout << endl; 


  for (int i=0; i<8; i++) {
    cout << labels[i] <<  "  ";
    for (int j=0; j<8; j++) {
      cout <<  bitmap[ convert_op[i] + convert_me[j] ] << "    "; 
    }
    cout << endl; 
  }
} 
